; 8-bit pseudo-random number generator
; ====================================

; initialize _prng_seed to nonzero
; before calling _prng.

.segment "ZEROPAGE"
.export _prng_seed
_prng_seed: .res 1

.segment "ASM"
.export _prng
.proc _prng
    ldx #0 ; cc65 expects 16-bit return value in A/X
    lda _prng_seed
    asl
    bcc :+
        eor #$4D
    :
    eor #$59
    sta _prng_seed
    rts
.endproc

; end of file